#pragma once

#ifndef ERROR_H

#include <stdint.h>

typedef enum error {
	ERROR_NONE,
	ERROR_MEMORY,

	//compiler errors
	ERROR_UNEXPECTED_TOK,

	ERROR_TYPE_NOT_ALLOWED,
	ERROR_NO_TYPE_ARG,

	ERROR_EXPECTED_SUB_TYPES,
	ERROR_TO_MANY_SUB_TYPES,

	ERROR_UNDECLARED_VAR,
	ERROR_UNEXPECTED_TYPE,
	ERROR_UNEXPECTED_ARGUMENT_LENGTH,

	ERROR_CANNOT_RETURN,
	ERROR_CANNOT_CONTINUE,
	ERROR_CANNOT_BREAK,

	//virtual-machine errors
	ERROR_INSUFFICIENT_POSITIONS,
	ERROR_INDEX_OUT_OF_RANGE,
	ERROR_STACK_OVERFLOW,
	ERROR_READ_UNINIT,
	
	ERROR_ABORT,

	ERROR_CANNOT_OPEN_FILE
} error_t;

#define PANIC(OBJ, ERROR){ OBJ->last_err = ERROR; return 0; }
#define ESCAPE_ON_NULL(PTR) {if(!(PTR)) { return 0; }}
#define PANIC_ON_NULL(PTR, OBJ, ERROR) {if(!(PTR)) PANIC(OBJ, ERROR)}

#endif // !ERROR_H
